<?php
//$Id:

/**
 *
 * @author Raphael Schr - www.schaerwebdesign.ch
 *
 */
class FastGalleryAccess{
	private static $instance = null;

	/**
	 * We are implementing a singleton pattern
	 */
	private function __construct() {
	}

	public function getInstance() {
		if (is_null(self::$instance)) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	// =============================================
	// Here comes the real code
	// =============================================

	/**
	 *	Fetching all the folders that are in the hierarchie
	 *  @param string $path
	 *  @return array
	 */
	public function getFolderHierarchie($path){
		$files = array();

		$dirs = glob($path.'*', GLOB_ONLYDIR);
		$dirs_new = array();
		foreach ($dirs as $key => $dir) {
			$dirs_new[$dir] = $dir;
		}
		foreach ($dirs_new as $key => $dir) {
			$dirs_new[$key] = $this->getFolderHierarchie($dir.'/');
		}

		return $dirs_new;
	}

	public function flattenFolders(array $array,$return=array(),$depth=0)
	{
		if($depth == 0){
			$tmpPath = substr(variable_get('fast_gallery_path', ''),0,-1);
			$return[] = array('folder'=>$tmpPath,'depth'=>$depth);
		}
		$depth++;
		foreach($array as $key => $folder)
		{
			$return[] = array('folder'=>$key,'depth'=>$depth);
			if(is_array($folder))
			{
				$return = $this->flattenFolders($folder,$return,$depth);
			}
			
		}
		return $return;
	}
}
